; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_SPEICHERN_AUTO:
	LDS temp,(adr_FREIGABE_TAG)
	tst temp
	brne EEPROM_KONFIGURATION_SPEICHERN_AUTO_RUN
	ret
EEPROM_KONFIGURATION_SPEICHERN_AUTO_RUN:
	rcall EEPROM_KONFIGURATION_SPEICHERN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_SPEICHERN:
	cbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung an	
	rcall wait_1s
	sbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung aus

	ldi ZL, LOW(10)	; EEPROM Adresse
	ldi ZH,HIGH(10)

	ldi YL, LOW(SRAM_START)	; SRAM Adresse
	ldi YH,HIGH(SRAM_START)

	ldi temp9,10
EEPROM_KONFIGURATION_SPEICHERN_s:
	LD temp,Y+	; aus SRAM laden und Y +1
	rcall EEPROM_WRITE_PLUS_Z_TEMP
	dec temp9
	brne EEPROM_KONFIGURATION_SPEICHERN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_LADEN:
	ldi ZL, LOW(10)			; EEPROM Adresse
	ldi ZH,HIGH(10)

	ldi YL, LOW(SRAM_START)	; SRAM Adresse
	ldi YH,HIGH(SRAM_START)
	; Plausibilitt		
	rcall EEPROM_READ_PLUS_Z_TEMP	; JAHR	
	cpi temp,100
	brsh EEPROM_KONFIGURATION_LADEN_ERROR
	rcall EEPROM_READ_PLUS_Z_TEMP	; MONAT	
	cpi temp,12+1
	brsh EEPROM_KONFIGURATION_LADEN_ERROR
	rcall EEPROM_READ_PLUS_Z_TEMP	; TAG	
	cpi temp,31+1
	brsh EEPROM_KONFIGURATION_LADEN_ERROR
	rcall EEPROM_READ_PLUS_Z_TEMP	; STUNDE
	cpi temp,24+1
	brsh EEPROM_KONFIGURATION_LADEN_ERROR
	rcall EEPROM_READ_PLUS_Z_TEMP	; MINUTE
	cpi temp,59+1
	brsh EEPROM_KONFIGURATION_LADEN_ERROR
;-------------------------------------------------------------------------------
	ldi ZL, LOW(10)			; EEPROM Adresse
	ldi ZH,HIGH(10)

	ldi YL, LOW(SRAM_START)	; SRAM Adresse
	ldi YH,HIGH(SRAM_START)

	ldi temp9,10
EEPROM_KONFIGURATION_LADEN_s:
	rcall EEPROM_READ_PLUS_Z_TEMP
	ST Y+,temp
	dec temp9
	brne EEPROM_KONFIGURATION_LADEN_s

	rcall LCD_CONTRAST

	ret
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_LADEN_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR		; ROT  an	
	rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte aus EEPROM laden und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	TEMP (DATEN)														
;																				
EEPROM_READ_PLUS_Z_TEMP:
	WDR
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_PLUS_Z_TEMP
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; 		 	TEMP  DATEN															
;																				
EEPROM_WRITE_PLUS_Z_TEMP:
	WDR
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_PLUS_Z_TEMP
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
;-------------------------------------------------------------------------------
	push temp1
	in 	 temp1,EEDR		; Read data from data register			
	cp temp,temp1
	brne EEPROM_WRITE_PLUS_Z_TEMP_RUN
	pop temp1
	adiw ZL,1			; ADRESSE +1 							
	ret
;-------------------------------------------------------------------------------
EEPROM_WRITE_PLUS_Z_TEMP_RUN:
	pop temp1
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

