; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_BETRAG8_TEMP1:
	tst temp1
	brmi FUNCTION_BETRAG8_TEMP1_N
	ret
FUNCTION_BETRAG8_TEMP1_N:
	com temp1
	inc temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_BETRAG16_TEMP1_TEMP2:
	tst temp2
	brmi FUNCTION_BETRAG16_TEMP1_TEMP2_RUN
	ret
FUNCTION_BETRAG16_TEMP1_TEMP2_RUN:
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 6 x rechts (signiert)															
FUNKTION_DIVISION_32_DURCH_64_SIGNIERT:
	ldi temp,6
FUNKTION_DIVISION_32_DURCH_64_SIGNIERT_s:
	CLC			; CLEAR CARRY				
	SBRC temp2,7; Sprung, wenn CARRY clear	
	SEC			; SET CARRY					
	ROR temp2	; 1x rechts ber CARYY		
	ROR temp1	; 1x rechts ber CARYY		
	dec temp
	brne FUNKTION_DIVISION_32_DURCH_64_SIGNIERT_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNKTION_DIVISION32_2_HOCH_TEMP:
	; Hilfsregister	
	push temp
	push temp5
	push temp6
	push temp7
	push temp8

	dec temp
	ldi temp5,1
	clr temp6
	clr temp7
	clr temp8
;-------------------------------------------------------------------------------
; halben Devisor dazu addieren													
FUNKTION_DIVISION32_2_HOCH_TEMP_w:
	LSL temp5
	ROL temp6
	ROL temp7
	ROL temp8
	dec temp
	brne FUNKTION_DIVISION32_2_HOCH_TEMP_w
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	pop temp8
	pop temp7
	pop temp6
	pop temp5
	pop temp
;-------------------------------------------------------------------------------
FUNKTION_DIVISION32_2_HOCH_TEMP_S:
	LSR temp4
	ROR temp3
	ROR temp2
	ROR temp1
	dec temp
	brne FUNKTION_DIVISION32_2_HOCH_TEMP_S
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor 	(0...65.535 (xFFFF) 							
;			TEMP3 / TEMP4	2.Faktor	(0...65.535 (xFFFF)  							
; 																						
; 	OUTPUT: 	TEMP1...4		Produkt		(4.294.836.225 (FF-FE-00-01)				
; 																						
;	HILFSREGISTER: R0,R1,R2,R3															
;																						
FUNKTION_MULTIPLIKATION_16_16_32:
; Hilfsregister sichern	(STACK)	
	push R0
	push R1
	push R2
	push R3
	push temp5
	push temp6
; Hilfsregister lschen			
	clr temp5
	clr temp6
	clr R0
	clr R1
	clr R2
	clr R3
MUL_16_16_w:
	LSR temp4			; 2.Faktor 1x rechts 		
	ROR temp3
	BRCC MUL_16_16_ww	; kein C rollt heraus 		
	add R0, temp1		; 1. FAKOR addieren			
	adc R1, temp2
	adc R2, temp5
	adc R3, temp6
MUL_16_16_ww:	 
	LSL temp1			; 1. FAKOR 1x links			
	ROL temp2
	ROL temp5
	ROL temp6

	TST temp3			; 2.Faktor = NULL (LOW) ?	
	brne MUL_16_16_w
	TST temp4			; 2.Faktor = NULL (HIGH)?	
	brne MUL_16_16_w

	mov temp1, R0		; ERGEBNIS KOPIEREN 		
	mov temp2, R1
	mov temp3, R2
	mov temp4, R3

; REGISTER wieder herstellen	
	pop temp6
	pop temp5
	pop R3
	pop R2
	pop R1
	pop R0
ret
;#######################################################################
;#######################################################################
;#######################################################################
;																		
;		INPUT 	temp1  (LOW)											
;		INPUT 	temp2  													
;		INPUT 	temp3  													
;		INPUT 	temp4  (HIGH)											
;					 													
;		OUTPUT 	temp1 (LOW) 											
;		OUTPUT 	temp2 (HIGH)											
;																		
;		Hilfsregister: R0,R1,R14,R15,R16,R21,R22,R23,R24				
;																		
WURZEL_32:
; HILFSREGISTER sichern	(STACK)						
	push R0
	push R1
	push R14
	push R15
	push R16
	push R21
	push R22
	push R23
	push R24
; HILFSREGISTER initialisieren 						
	ldi temp, 1
	mov R14, temp		;= 1						
	ldi temp, 2
	mov R15, temp		;= 2						
	clr   temp
	clr   r0          	; ERGEBNIS					
    clr   r1 
    ldi   r21,1        	;= 1						
    clr   r22 
    clr   r23 
    clr   r24 

; Wurzel-Berechnung									
WURZEL_32_w:
	sub   temp1,R21 	; SUBTRAKTION 				
    sbc   temp2,R22 
    sbc   temp3,R23 
    sbc   temp4,R24 
    brlo  WURZEL_32_ww
    add   R0,R14 		; ADDITION +1(Ergebnis)		
    adc   R1,temp 
    add   R21,R15 		; ADDITION +2			 	
    adc   R22,temp 
    adc   R23,temp 
    adc   R24,temp 
    rjmp  WURZEL_32_w
WURZEL_32_ww:   
	mov temp1,r0 		; ERGEBNIS KOPIEREN			
    mov temp2,r1 
; HILFSREGISTER wieder herstellen (STACK) 			
	pop R24
	pop R23
	pop R22
	pop R21
	pop R16
	pop R15
	pop R14
	pop R1
	pop R0
ret
;########################################################################
;########################################################################
;########################################################################
