; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_CHECK:
	; LCD_PAGE_0_CLEAR
	rcall LCD_PAGE_0_CLEAR
	ldi temp,'B'				; 
	STS(adr_LCD_PAGE0+0),temp
	ldi temp,'M'				; 
	STS(adr_LCD_PAGE0+1),temp
	ldi temp,'A'				; 
	STS(adr_LCD_PAGE0+2),temp
	ldi temp,':'				; 
	STS(adr_LCD_PAGE0+3),temp
	ldi temp,' '				; 
	STS(adr_LCD_PAGE0+4),temp
	rcall LCD_ZEICHNEN
	; ADRESSE			
	ldi temp1,(ADRESSE_BMA020)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	rcall TWI_STOP								; STOP				
	; ERROR ?			
	tst TWI_FEHLER_CODE
	brne BMA020_CHECK_ERROR
;-------------------------------------------------------------------------------
BMA020_CHECK_OK:
	STS(adr_BMA020_VORHANDEN),VOLL	; vorhanden !

	ldi temp,'O'				; 
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'K'				; 
	STS(adr_LCD_PAGE0+6),temp
	rcall LCD_ZEICHNEN
	rcall WAIT_100ms
	ret
;-------------------------------------------------------------------------------
BMA020_CHECK_ERROR:
	ldi temp,'?'				; 
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'?'				; 
	STS(adr_LCD_PAGE0+6),temp
	rcall LCD_ZEICHNEN
	rcall WAIT_1s
	clr TWI_FEHLER_CODE
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; REGISTER 14h																	
; 00--- => RANGE +/- 2g															
; 01--- => RANGE +/- 4g															
; 10--- => RANGE +/- 8g															
; --000 => BANDWITH 25Hz														
; --001 => BANDWITH 50Hz														
; --010 => BANDWITH 100Hz														
; --011 => BANDWITH 190Hz														
; --100 => BANDWITH 375Hz														
; --101 => BANDWITH 750Hz														
; --110 => BANDWITH 1500Hz														
;																				
BMA020_INITIALISIERUNG:
	; REGISTER 14h							
	ldi temp1,(0x14)						; Register-ADRESSE	
	rcall BMA020_REGISTER_READ_TEMP1
	andi temp1,0b10000000
	ori  temp1,0b00000000
	mov temp2,temp1							; Register-INHALT	
	ldi temp1,(0x14)						; Register-ADRESSE	
	rcall BMA020_REGISTER_WRITE_TEMP1_TEMP2
	; REGISTER 15h							
	ldi temp1,(0x15)						; Register-ADRESSE	
	rcall BMA020_REGISTER_READ_TEMP1
	ori  temp1,0b00100000
	mov temp2,temp1							; Register-INHALT	
	ldi temp1,(0x15)						; Register-ADRESSE	
	rcall BMA020_REGISTER_WRITE_TEMP1_TEMP2



ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Registerinhalt eines Registers auslesen										
; INP: temp1 (Register-ADRESSE)													
; OUT: temp1 (Register-INHALT)													
BMA020_REGISTER_READ_TEMP1:
	push temp1									; Register-ADRESSE	
	ldi temp1,(ADRESSE_BMA020)					; I2C-ADRESSE		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-MT			
	pop temp1									; Register-ADRESSE	
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1	; BYTE-WRITE		
	ldi temp1,(ADRESSE_BMA020)					; I2C-ADRESSE		
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; START-MR			
	rcall TWI_MASTER_RECEIVER_LAST_BYTE_TEMP1	; LAST BYTE read	
	rcall TWI_STOP								; STOP				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1 (Register-ADRESSE)													
; INP: temp2 (Register-INHALT)													
BMA020_REGISTER_WRITE_TEMP1_TEMP2:
	push temp1									; Register-ADRESSE	
	ldi temp1,(ADRESSE_BMA020)					; I2C-ADRESSE		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-MT			
	pop temp1									; Register-ADRESSE	
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1	; BYTE-WRITE		
	mov temp1,temp2
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1	; BYTE-WRITE		
	rcall TWI_STOP								; STOP				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_MESSUNG:
	; SENSOR vorhanden ?		
	LDS temp,(adr_BMA020_VORHANDEN)
	tst temp
	brne BMA020_MESSUNG_RUN
	ret
;-------------------------------------------------------------------------------
BMA020_MESSUNG_RUN:
	; OLD speichern				
	LDS temp1,(adr_BMA020_X_LSB)
	LDS temp2,(adr_BMA020_X_MSB)
	STS(adr_BMA020_X_OLD_LSB),temp1
	STS(adr_BMA020_X_OLD_MSB),temp2

	LDS temp1,(adr_BMA020_Y_LSB)
	LDS temp2,(adr_BMA020_Y_MSB)
	STS(adr_BMA020_Y_OLD_LSB),temp1
	STS(adr_BMA020_Y_OLD_MSB),temp2

	LDS temp1,(adr_BMA020_Z_LSB)
	LDS temp2,(adr_BMA020_Z_MSB)
	STS(adr_BMA020_Z_OLD_LSB),temp1
	STS(adr_BMA020_Z_OLD_MSB),temp2
	; Messung initialisieren	
	ldi temp1,(ADRESSE_BMA020)					; I2C-ADRESSE		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-MT			
	; ERROR						
	tst TWI_FEHLER_CODE
	brne BMA020_MESSUNG_ERROR_TWI
	ldi temp1,(0x02)							; Register-ADRESSE	
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1	; BYTE-WRITE		
	; ERROR						
	tst TWI_FEHLER_CODE
	brne BMA020_MESSUNG_ERROR_TWI
	; 6 Bytes auslesen			
	ldi temp1,(ADRESSE_BMA020)					; I2C-ADRESSE		
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; START-MR			
	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_BMA020_X_LSB),temp1
	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_BMA020_X_MSB),temp1

	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_BMA020_Y_LSB),temp1
	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_BMA020_Y_MSB),temp1

	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1		; BYTE read			
	STS(adr_BMA020_Z_LSB),temp1
	rcall TWI_MASTER_RECEIVER_LAST_BYTE_TEMP1	; LAST BYTE read	
	STS(adr_BMA020_Z_MSB),temp1
	rcall TWI_STOP								; STOP				
	; ERROR						
	tst TWI_FEHLER_CODE
	brne BMA020_MESSUNG_ERROR_TWI
	; ERROR (MESSWERTE)			
	LDS temp,(adr_BMA020_X_LSB)
	sbrs temp,0					; Skip if...
	rjmp BMA020_MESSUNG_ERROR
	LDS temp,(adr_BMA020_Y_LSB)
	sbrs temp,0					; Skip if...
	rjmp BMA020_MESSUNG_ERROR
	LDS temp,(adr_BMA020_Z_LSB)
	sbrs temp,0					; Skip if...
	rjmp BMA020_MESSUNG_ERROR
	; BERECHNUNG				
	rcall BMA020_BERECHNUNG
ret
;-------------------------------------------------------------------------------
BMA020_MESSUNG_ERROR:
	ldi temp,(ERROR_BMA020_MESSUNG)	
	rcall ERROR_SPEICHERN_TEMP
	rjmp BMA020_MESSUNG_RUN	
;-------------------------------------------------------------------------------
BMA020_MESSUNG_ERROR_TWI:
	rcall TWI_STOP	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_BERECHNUNG:
	; BITs 6xrechts (signiert)	
	LDS temp1,(adr_BMA020_X_LSB)
	LDS temp2,(adr_BMA020_X_MSB)
	rcall FUNKTION_DIVISION_32_DURCH_64_SIGNIERT
	STS(adr_BMA020_X_LSB),temp1
	STS(adr_BMA020_X_MSB),temp2
	; BITs 6xrechts (signiert)	
	LDS temp1,(adr_BMA020_Y_LSB)
	LDS temp2,(adr_BMA020_Y_MSB)
	rcall FUNKTION_DIVISION_32_DURCH_64_SIGNIERT
	STS(adr_BMA020_Y_LSB),temp1
	STS(adr_BMA020_Y_MSB),temp2
	; BITs 6xrechts (signiert)	
	LDS temp1,(adr_BMA020_Z_LSB)
	LDS temp2,(adr_BMA020_Z_MSB)
	rcall FUNKTION_DIVISION_32_DURCH_64_SIGNIERT
	STS(adr_BMA020_Z_LSB),temp1
	STS(adr_BMA020_Z_MSB),temp2
;-------------------------------------------------------------------------------
	; OFFSET SUBTRAHIEREN (X)			
	LDS temp1,(adr_BMA020_X_LSB)
	LDS temp2,(adr_BMA020_X_MSB)
	LDS temp3,(adr_BMA020_X_OFFS_LSB)
	LDS temp4,(adr_BMA020_X_OFFS_MSB)
	sub temp1,temp3
	sbc temp2,temp4
	STS(adr_BMA020_X),temp1
	; OFFSET SUBTRAHIEREN (Y)			
	LDS temp1,(adr_BMA020_Y_LSB)
	LDS temp2,(adr_BMA020_Y_MSB)
	LDS temp3,(adr_BMA020_Y_OFFS_LSB)
	LDS temp4,(adr_BMA020_Y_OFFS_MSB)
	sub temp1,temp3
	sbc temp2,temp4
	STS(adr_BMA020_Y),temp1
	; OFFSET SUBTRAHIEREN (Z)			
	LDS temp1,(adr_BMA020_Z_LSB)
	LDS temp2,(adr_BMA020_Z_MSB)
	LDS temp3,(adr_BMA020_Z_OFFS_LSB)
	LDS temp4,(adr_BMA020_Z_OFFS_MSB)
	sub temp1,temp3
	sbc temp2,temp4
	STS(adr_BMA020_Z),temp1
;-------------------------------------------------------------------------------
	; g berechnen		
	STS(adr_BMA020_G_LSB),NULL
	STS(adr_BMA020_G_MSB),NULL
	LDS temp1,(adr_BMA020_X_LSB)
	LDS temp2,(adr_BMA020_X_MSB)
	rcall BMA020_BERECHNUNG_G_TEMP1_TEMP2
	LDS temp1,(adr_BMA020_Y_LSB)
	LDS temp2,(adr_BMA020_Y_MSB)
	rcall BMA020_BERECHNUNG_G_TEMP1_TEMP2
	LDS temp1,(adr_BMA020_Z_LSB)
	LDS temp2,(adr_BMA020_Z_MSB)
	rcall BMA020_BERECHNUNG_G_TEMP1_TEMP2
	; WURZEL							
	LDS temp1,(adr_BMA020_G_LSB)
	LDS temp2,(adr_BMA020_G_MSB)
	clr temp3
	clr temp4
	rcall WURZEL_32
	STS(adr_BMA020_G_LSB),temp1
	STS(adr_BMA020_G_MSB),temp2
ret
;-------------------------------------------------------------------------------
BMA020_BERECHNUNG_G_TEMP1_TEMP2:
	; BETRAG				
	rcall FUNCTION_BETRAG16_TEMP1_TEMP2
	mov temp3,temp1
	mov temp4,temp2
	; ^2					
	rcall FUNKTION_MULTIPLIKATION_16_16_32
	; laden					
	LDS temp3,(adr_BMA020_G_LSB)
	LDS temp4,(adr_BMA020_G_MSB)
	; addieren				
	add temp1,temp3
	adc temp2,temp4
	; SPEICHERN				
	STS(adr_BMA020_G_LSB),temp1
	STS(adr_BMA020_G_MSB),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_ALARM:
	; X					
	LDS temp1,(adr_BMA020_X_LSB)
	LDS temp2,(adr_BMA020_X_MSB)
	LDS temp3,(adr_BMA020_X_OLD_LSB)
	LDS temp4,(adr_BMA020_X_OLD_MSB)
	rcall BMA020_ALARM_AUSWERTUNG
	; Y					
	LDS temp1,(adr_BMA020_Y_LSB)
	LDS temp2,(adr_BMA020_Y_MSB)
	LDS temp3,(adr_BMA020_Y_OLD_LSB)
	LDS temp4,(adr_BMA020_Y_OLD_MSB)
	rcall BMA020_ALARM_AUSWERTUNG
	; Z					
	LDS temp1,(adr_BMA020_Z_LSB)
	LDS temp2,(adr_BMA020_Z_MSB)
	LDS temp3,(adr_BMA020_Z_OLD_LSB)
	LDS temp4,(adr_BMA020_Z_OLD_MSB)
	rjmp BMA020_ALARM_AUSWERTUNG
;-------------------------------------------------------------------------------
BMA020_ALARM_AUSWERTUNG:
	; DIFFERENZ			
	sub temp1,temp3
	sbc temp2,temp4
	; BETRAG				
	rcall FUNCTION_BETRAG16_TEMP1_TEMP2
	tst temp2 		; HIGH-BYTE	
	brne BMA020_ALARM_AUSWERTUNG_RUN
	LDS temp,(adr_ALARM_SCHWELLE); Schwelle laden	
	cp temp1,temp	; LOW-BYTE	
	brsh BMA020_ALARM_AUSWERTUNG_RUN
	ret
;-------------------------------------------------------------------------------
BMA020_ALARM_AUSWERTUNG_RUN:
	LDS temp,(adr_ALARM_WERT)	; aus SRAM laden			
	tst temp
	breq BMA020_ALARM_AUSWERTUNG_ACTION
	ret
;-------------------------------------------------------------------------------
BMA020_ALARM_AUSWERTUNG_ACTION:
	STS(adr_ALARM_WERT),EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_OFFSET_SCHNELL:
	rcall BMA020_MESSUNG
	LDS temp1,(adr_BMA020_X_LSB)
	LDS temp2,(adr_BMA020_X_MSB)
	STS(adr_BMA020_X_OFFS_LSB),temp1
	STS(adr_BMA020_X_OFFS_MSB),temp2

	LDS temp1,(adr_BMA020_Y_LSB)
	LDS temp2,(adr_BMA020_Y_MSB)
	STS(adr_BMA020_Y_OFFS_LSB),temp1
	STS(adr_BMA020_Y_OFFS_MSB),temp2

	LDS temp1,(adr_BMA020_Z_LSB)
	LDS temp2,(adr_BMA020_Z_MSB)
	STS(adr_BMA020_Z_OFFS_LSB),temp1
	STS(adr_BMA020_Z_OFFS_MSB),temp2

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_OFFSET_AUTO:
	LDS temp,(adr_FREIGABE_ss)
	tst temp
	brne BMA020_OFFSET_AUTO_RUN
	ret
BMA020_OFFSET_AUTO_RUN:
	; X											
	LDS temp,(adr_BMA020_X)
	LDS temp1,(adr_BMA020_X_OFFS_LSB)
	LDS temp2,(adr_BMA020_X_OFFS_MSB)
	rcall BMA020_OFFSET_FUNCTION
	STS(adr_BMA020_X_OFFS_LSB),temp1
	STS(adr_BMA020_X_OFFS_MSB),temp2
	; Y											
	LDS temp,(adr_BMA020_Y)
	LDS temp1,(adr_BMA020_Y_OFFS_LSB)
	LDS temp2,(adr_BMA020_Y_OFFS_MSB)
	rcall BMA020_OFFSET_FUNCTION
	STS(adr_BMA020_Y_OFFS_LSB),temp1
	STS(adr_BMA020_Y_OFFS_MSB),temp2
	; Z											
	LDS temp,(adr_BMA020_Z)
	LDS temp1,(adr_BMA020_Z_OFFS_LSB)
	LDS temp2,(adr_BMA020_Z_OFFS_MSB)
	rcall BMA020_OFFSET_FUNCTION
	STS(adr_BMA020_Z_OFFS_LSB),temp1
	STS(adr_BMA020_Z_OFFS_MSB),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_OFFSET_FUNCTION:
	tst temp
	brne BMA020_OFFSET_FUNCTION_RUN
	ret
BMA020_OFFSET_FUNCTION_RUN:
	ldi temp3, LOW(1)
	ldi temp4,HIGH(1)
	tst temp
	brpl BMA020_OFFSET_FUNCTION_w
	ldi temp3, LOW(-1)
	ldi temp4,HIGH(-1)
BMA020_OFFSET_FUNCTION_w:
	add temp1,temp3
	adc temp2,temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

