; ##############################################################################
; ##############################################################################
; ##############################################################################
WATCHDOG_AKTIVIEREN:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	WDR
	; LEDs an									
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	cbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung an	
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN		
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB		
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT		
	sbi (LED_BEL_DDR),(LED_BEL_PIN_NR)			; Beleuchtung
	; LEDs an									
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	cbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	sbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung aus

	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	rcall wait_100ms
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	rcall wait_100ms
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	cbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	sbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung aus
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; den ersten auftretenden FEHLER speichern										
ERROR_SPEICHERN_TEMP:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR		; ROT  an	
	LDS temp1,(adr_ERROR)
	tst temp1
	breq ERROR_SPEICHERN_TEMP_RUN
	ret
ERROR_SPEICHERN_TEMP_RUN:
	STS(adr_ERROR),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_INITIALISIERUNG:	
	; auf EINGANG		
	cbi (TASTE_MENUE_PLUS_DDR), (TASTE_MENUE_PLUS_PIN_NR)
	cbi (TASTE_MENUE_MINUS_DDR), (TASTE_MENUE_MINUS_PIN_NR)
	cbi (TASTE_PLUS_DDR),(TASTE_PLUS_PIN_NR)
	cbi (TASTE_MINUS_DDR),(TASTE_MINUS_PIN_NR)

	; PULL-UP ein		
	sbi (TASTE_MENUE_PLUS_PORT),(TASTE_MENUE_PLUS_PIN_NR)
	sbi (TASTE_MENUE_MINUS_PORT),(TASTE_MENUE_MINUS_PIN_NR)
	sbi (TASTE_PLUS_PORT),(TASTE_PLUS_PIN_NR)
	sbi (TASTE_MINUS_PORT),(TASTE_MINUS_PIN_NR)

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ABFRAGE_TASTATUR:
	clr temp
ABFRAGE_TASTATUR_s:
	; Taste "MENUE-PLUS"gedrckt ?	
	sbis (TASTE_MENUE_PLUS_PIN),(TASTE_MENUE_PLUS_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,1
	; Taste "MENUE-MINUS"gedrckt ?	
	sbis (TASTE_MENUE_MINUS_PIN),(TASTE_MENUE_MINUS_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,2
	; Taste "PLUS"gedrckt ?		
	sbis (TASTE_PLUS_PIN),(TASTE_PLUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,4
	; Taste "MINUS"gedrckt ?		
	sbis (TASTE_MINUS_PIN),(TASTE_MINUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,8
	; speichern						
	STS(adr_TASTE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_RUN
	ret
TASTEN_WAIT_RUN:
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
	STS(adr_TASTE),NULL
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

