; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_INITIALISIERUNG:
; SPCR => SPIE SPE DORD MSTR CPOL CPHA SPR1 SPR0 (SPI Control Register)		
; 																			
; SPIE: SPI Interrupt Enable												
; SPE:  SPI Enable															
; DORD: Data Order															
; MSTR: Master/Slave Select													
; CPOL: Clock Polarity														
; CPHA: Clock Phase															
;						   Leading Edge 	Trailing Edge 		SPI Mode	
;	*	CPOL = 0, CPHA = 0 Sample (Rising) 	Setup (Falling) 		0		
;		CPOL = 0, CPHA = 1 Setup (Rising) 	Sample (Falling) 		1		
;		CPOL = 1, CPHA = 0 Sample (Falling) Setup (Rising) 			2		
;		CPOL = 1, CPHA = 1 Setup (Falling) 	Sample (Rising) 		3		
; SPR1: SPI Clock Rate Select 1												
; SPR0: SPI Clock Rate Select 0												
; 		SPR1 SPR0 SCK Frequency												
;  		0    0   fosc/4														
;  		0    1   fosc/16													
;  		1    0   fosc/64													
;  	*	1    1   fosc/128													
;																			

	sbi DDRB,LCD_RES	; SLAVE-RESET	
	sbi DDRB,LCD_A0		; SLAVE-A0		
	sbi DDRB,LCD_CS		; MASTER CS		
	sbi DDRB,LCD_SI		; MASTER MOSI	
	sbi DDRB,LCD_SCL	; MASTER SCK	



	ldi temp,(0<<SPIE)|(1<<SPE)|(0<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)|(0<<SPR1)|(0<<SPR0)
	out SPCR,temp

; SPSR => SPIF WCOL - - - - - SPI2X  (SPI Status Register )					
;																			
; SPIF:  SPI Interrupt Flag													
; WCOL:  Write COLlision Flag												
; SPI2X: Double SPI Speed Bit												
;																			
; Double SPI Speed = off													
	ldi temp,(0<<SPI2X)
	out SPSR,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: TEMP																		
; out: TEMP																		
;																				
SPI_TX_RX_TEMP:
	; Start transmission of data 	
	out SPDR,temp
	; Wait for transmission complete
SPI_TX_RX_TEMP_w:
	sbis SPSR,SPIF
	rjmp SPI_TX_RX_TEMP_w
	; DATENBYTE EINLESEN			
	in temp, SPDR	; einlesen  
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
