; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER1_INITIALISIERUNG:
;																			
; Timer1 (16Bit ) Vorteiler 												
;																			
; TCCR1B ==> ICNC1 ICES1 RESERVIERT WGM13 WGM12 CS12 CS11 CS10 				
;																			
;CS12 CS11 CS10 Description													
;	0	0 	0 	No clock source. (Timer/Counter stopped)					
;	0 	0 	1 	clkI/O/1    (No prescaling)									
;	0 	1 	0 	clkI/O/8    (From prescaler)								
;	0 	1 	1 	clkI/O/64   (From prescaler)								
;	1 	0 	0 	clkI/O/256  (From prescaler)								
;* 	1 	0 	1 	clkI/O/1024 (From prescaler)								
;	1 	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;	1 	1 	1 	External clock source on T1 pin. Clock on rising edge.		
;																			
	ldi temp,(1<<CS12)|(0<<CS11) |(0<<CS10)
	out TCCR1B,temp          
; Timer 1 Startwert 	
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp     
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER_AKTIVIEREN:
;																			
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(1<<TOIE1)|(0<<TOIE0)
	out TIMSK,temp         
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz ==> 100ms Takt														
TIM1_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
; ----------------------------------
; Timer Startwert	 				
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp
; -------------------------------
	rcall ZEIT
	rcall ABFRAGE_TASTATUR
; ----------------------------------
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
ALARM_TIMER:
	LDS temp,(adr_ALARM_WERT)	; aus SRAM laden			
	tst temp
	breq ALARM_TIMER_FERTIG
	cbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung an	
	cpi temp,255
	breq ALARM_TIMER_FERTIG
	inc temp
	STS(adr_ALARM_WERT),temp
ALARM_TIMER_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT:
	; FREIGABE	
	STS (adr_FREIGABE_ss10),EINS

	LDS temp,(adr_ss10)	; aus SRAM laden			
	inc temp
	STS (adr_ss10),temp	; in SRAM speichern	
	cpi temp,10
	brsh ZEIT_ss
	ret	
;-------------------------------------------------------------------------------
; SEKUNDEN																		
ZEIT_ss:
	STS (adr_ss10),NULL	; in SRAM speichern	
	; FREIGABE	
	STS (adr_FREIGABE_ss),EINS
	; ALARM_TIMER	
	rcall ALARM_TIMER
	LDS temp,(adr_ss)	; aus SRAM laden			
	inc temp
	STS (adr_ss),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_MM
	ret	
;-------------------------------------------------------------------------------
; MINUTEN																		
ZEIT_MM:
	STS (adr_ss),NULL	; in SRAM speichern	
	; FREIGABE	
	STS (adr_FREIGABE_mm),EINS
	LDS temp,(adr_mm)	; aus SRAM laden	
	inc temp
	STS (adr_mm),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_HH
	ret	
;-------------------------------------------------------------------------------
; STUNDEN																		
ZEIT_HH:
	STS (adr_mm),NULL	; in SRAM speichern	
	; FREIGABE	
	STS (adr_FREIGABE_hh),EINS

	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	STS (adr_hh),temp	; in SRAM speichern	
	cpi temp,24
	brsh ZEIT_TAG
	ret	
;-------------------------------------------------------------------------------
; TAG					
ZEIT_TAG:
	STS (adr_hh),NULL	; in SRAM speichern	
	; FREIGABE	
	STS(adr_FREIGABE_TAG),EINS

	LDS temp,(adr_TAG)	; aus SRAM laden	
	inc temp
	STS (adr_TAG),temp	; in SRAM speichern	
	; vergleich	
	rcall ZEIT_TAGE_IM_MONAT_TEMP1
	cp temp,temp1 
	breq ZEIT_TAG_w
	brsh ZEIT_MONAT
ZEIT_TAG_w:
	ret
;-------------------------------------------------------------------------------
; MONAT					
ZEIT_MONAT:
	STS (adr_TAG),EINS

	LDS temp,(adr_MONAT); aus SRAM laden	
	inc temp
	STS (adr_MONAT),temp; in SRAM speichern	
	cpi temp,13 
	brsh ZEIT_JAHR
	ret
; JAHR					
ZEIT_JAHR:
	; MONAT=1			
	STS (adr_MONAT),EINS
	; JAHR+1			
	LDS temp,(adr_JAHR)	; aus SRAM laden	
	inc temp
	STS (adr_JAHR),temp	; in SRAM speichern	
ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; OUT: temp1 (z.B. 31 fr DEZEMBER)												
; Anzahl der TAGE im Monat	
ZEIT_TAGE_IM_MONAT_TEMP1:
	; MONAT laden			
	LDS temp1,(adr_MONAT)
	; vergleich				
	cpi temp1,2			; Februar 28/29			
	breq ZEIT_TAGE_IM_MONAT_28
	cpi temp1,4			; April 30				
	breq ZEIT_TAGE_IM_MONAT_30
	cpi temp1,6			; Juni 30				
	breq ZEIT_TAGE_IM_MONAT_30
	cpi temp1,9			; September 30			
	breq ZEIT_TAGE_IM_MONAT_30
	cpi temp1,11		; November 30			
	breq ZEIT_TAGE_IM_MONAT_30
ZEIT_TAGE_IM_MONAT_31:
	ldi temp1,31		; MONATE mit 31 TAGEN	
	ret
ZEIT_TAGE_IM_MONAT_28:
	; Jahr laden					
	LDS temp1,(adr_JAHR)
	; SCHKEIFE						
ZEIT_TAGE_IM_MONAT_28s:
	; vergleich						
	subi temp1,4
	tst temp1
	; NULL=Schaltjahr				
	breq ZEIT_TAGE_IM_MONAT_29
	brpl ZEIT_TAGE_IM_MONAT_28s
	; negativ kein Schaltjahr		
	ldi temp1,28
	ret
ZEIT_TAGE_IM_MONAT_29:
	ldi temp1,29
	ret
ZEIT_TAGE_IM_MONAT_30:
	ldi temp1,30
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

; ##############################################################################
; ##############################################################################
; ##############################################################################
